#clocks
derive_pll_clocks -create_base_clocks

create_clock -period "25 MHz" -name altera_reserved_tck [get_keepers altera_reserved_tck]

create_clock -period "125 MHz" -name enet_rx_clk [get_ports enet_rx_clk]

#include other SDCs
source ddr2_top_phy_ddr_timing.sdc
#source ddr2_bot_phy_ddr_timing.sdc
#source  tse_mac_constraints.sdc

set ddr_sysclk "niosII_cycloneIII_3c120_host_board_sopc_inst|the_ddr2_top|ddr2_top_controller_phy_inst|alt_mem_phy_inst|ddr2_top_phy_alt_mem_phy_ciii_inst|clk|pll|altpll_component|auto_generated|pll1|clk[0]"
#set ddr_sysclk "niosII_cycloneIII_3c120_host_board_sopc_inst|the_ddr2_top|ddr2_top_controller_phy_inst|alt_mem_phy_inst|ddr2_top_phy_alt_mem_phy_ciii_inst|clk|pll|altpll_component|auto_generated|pll1|clk[1]"
set ddr_halfclk "niosII_cycloneIII_3c120_host_board_sopc_inst|the_ddr2_top|ddr2_top_controller_phy_inst|alt_mem_phy_inst|ddr2_top_phy_alt_mem_phy_ciii_inst|clk|pll|altpll_component|auto_generated|pll1|clk[0]"

#set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks {my_pll_inst|altpll_component|auto_generated|pll1|clk[0]}]
#set enet_tx_clk_2_5 "my_pll_inst|altpll_component|auto_generated|pll1|clk[0]"
#set enet_tx_clk_25 "my_pll_inst|altpll_component|auto_generated|pll1|clk[1]"
#set enet_tx_clk_125 "clkin_125"
set enet_tx_clk_2_5 "tse_clocks_inst|altpllpll_inst|altpll_component|auto_generated|pll1|clk[0]"
set enet_tx_clk_25 "tse_clocks_inst|altpllpll_1_inst|altpll_component|auto_generated|pll1|clk[0]"
set enet_tx_clk_125 "tse_clocks_inst|altpllpll_1_inst|altpll_component|auto_generated|pll1|clk[2]"

set pll_enet_rx_clk "tse_clocks_inst|altpllpll_2_inst|altpll_component|auto_generated|pll1|clk[0]"

#get rid of some clocks..
set_false_path -from [get_clocks {altera_reserved_tck}] -to [get_clocks *]
set_false_path -from [get_clocks *] -to [get_clocks {altera_reserved_tck}] 
#set_false_path -from [get_clocks {clkin_125}] -to [get_clocks *]
#set_false_path -from [get_clocks *] -to [get_clocks {clkin_125}]

#set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks {rx_clk_to_the_tse_mac}]
#set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks {rx_clk_to_the_tse_mac}]
#set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks {tx_clk_to_the_tse_mac}]
#set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks {tx_clk_to_the_tse_mac}]

#set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks {$enet_tx_clk_2_5}]
#set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks {$enet_tx_clk_25}]
#set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks {$enet_tx_clk_125}]

#set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks {$enet_tx_clk_2_5}]
#set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks {$enet_tx_clk_25}]
#set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks {$enet_tx_clk_125}]

#set_false_path -from [get_clocks $ddr_halfclk] -to [get_clocks {rx_clk_to_the_tse_mac}]
#set_false_path -to [get_clocks $ddr_halfclk] -from [get_clocks {rx_clk_to_the_tse_mac}]
#set_false_path -from [get_clocks $ddr_halfclk] -to [get_clocks {tx_clk_to_the_tse_mac}]
#set_false_path -to [get_clocks $ddr_halfclk] -from [get_clocks {tx_clk_to_the_tse_mac}]

#set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks $ddr_halfclk]
#set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks $ddr_halfclk]

set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks $enet_tx_clk_2_5]
set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks $enet_tx_clk_25]
set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks $enet_tx_clk_125]
set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks $enet_tx_clk_2_5]
set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks $enet_tx_clk_25]
set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks $enet_tx_clk_125]

set_false_path -from [get_clocks $ddr_sysclk] -to [get_clocks $pll_enet_rx_clk]
set_false_path -to [get_clocks $ddr_sysclk] -from [get_clocks $pll_enet_rx_clk]

set_clock_groups -exclusive -group $enet_tx_clk_2_5 -group $enet_tx_clk_25 -group $enet_tx_clk_125 -group $pll_enet_rx_clk

#set_clock_groups -exclusive -group {rx_clk_to_the_tse_mac} -group {clkin_125 my_pll_inst|altpll_component|auto_generated|pll1|clk[0] my_pll_inst|altpll_component|auto_generated|pll1|clk[1]}
#source hsmc_neek_lcd_interface.sdc
#create_neek_lcd_interface_constraints "hsmb"

#Cut the timing path betweeen unrelated clock domains
#set_clock_groups -exclusive -group {rx_clk_to_the_tse_mac} -group {tx_clk_to_the_tse_mac}
#set_clock_groups -exclusive -group {tx_clk_to_the_tse_mac} -group {rx_clk_to_the_tse_mac}

#cut path for sopc synch reset
set_false_path -from {niosII_cycloneIII_3c120_host_board_sopc:niosII_cycloneIII_3c120_host_board_sopc_inst|cpu:the_cpu|cpu_nios2_oci:the_cpu_nios2_oci|cpu_nios2_oci_debug:the_cpu_nios2_oci_debug|resetrequest} -to {niosII_cycloneIII_3c120_host_board_sopc:niosII_cycloneIII_3c120_host_board_sopc_inst|niosII_cycloneIII_3c120_host_board_sopc_reset_clk_domain_synch_module:niosII_cycloneIII_3c120_host_board_sopc_reset_clk_domain_synch|data_in_d1}
set_false_path -from {niosII_cycloneIII_3c120_host_board_sopc:niosII_cycloneIII_3c120_host_board_sopc_inst|cpu:the_cpu|cpu_nios2_oci:the_cpu_nios2_oci|cpu_nios2_oci_debug:the_cpu_nios2_oci_debug|resetrequest} -to {niosII_cycloneIII_3c120_host_board_sopc:niosII_cycloneIII_3c120_host_board_sopc_inst|niosII_cycloneIII_3c120_host_board_sopc_reset_clk_domain_synch_module:niosII_cycloneIII_3c120_host_board_sopc_reset_clk_domain_synch|data_out}
