module tse_clocks (
	input eth_mode,
	input ena_10,

	input clkin_125mhz,
	input rx_inclk,
	
	output tx_clk_core,
	output tx_clk_phy,
	output rx_outclk
);

wire top_pll_c0_out;
wire top_pll_c1_out;
wire top_pll_c3_out;
wire top_pll_c4_out;
wire top_pll_1_c0_out;
wire top_pll_1_c1_out;
wire top_pll_1_c2_out;
wire top_pll_1_c3_out;
wire top_pll_1_c4_out;
wire top_pll_2_c0_out;
wire tx_clk_phy_int;

altpllpll altpllpll_inst (
	.inclk0	(clkin_125mhz),
	.c0	(top_pll_c0_out),
	.c1	(top_pll_c1_out),
	.locked	()
);

altpllpll_1 altpllpll_1_inst (
	.inclk0	(clkin_125mhz),
	.c0	(top_pll_1_c0_out),
	.c1	(top_pll_1_c1_out),
	.c2	(top_pll_1_c2_out),
	.c3	(top_pll_1_c3_out),
	.c4	(top_pll_1_c4_out),
	.locked	()
);

altpllpll_2 altpllpll_2_inst (
	.inclk0	(rx_inclk),
	.c0	(rx_outclk),
	.locked	()
);

assign tx_clk_core = ( eth_mode == 1'b1 ? top_pll_1_c2_out : (ena_10 == 1'b1 ? top_pll_c0_out : top_pll_1_c0_out) ) ;
assign tx_clk_phy_int = ( eth_mode == 1'b1 ? top_pll_1_c3_out : (ena_10 == 1'b1 ? top_pll_c1_out : top_pll_1_c1_out) ) ;

altddio_out     altddio_out_component (
	.outclock (tx_clk_phy_int),
	.datain_h (1'b1),
	.datain_l (1'b0),
	.dataout (tx_clk_phy),
	.aclr (1'b0),
	.aset (1'b0),
	.oe (1'b1),
	.oe_out (),
	.outclocken (1'b1),
	.sclr (1'b0),
	.sset (1'b0));
	defparam
		altddio_out_component.extend_oe_disable = "UNUSED",
		altddio_out_component.intended_device_family = "Cyclone II",
		altddio_out_component.invert_output = "OFF",
		altddio_out_component.lpm_type = "altddio_out",
		altddio_out_component.oe_reg = "UNUSED",
		altddio_out_component.power_up_high = "OFF",
		altddio_out_component.width = 1;



endmodule

